<html><head><title>Homework: intro to xv6</title> <link rel="stylesheet" href="homework.css" type="text/css" /></head><body><h1>Homework: intro to xv6</h1><p>This lecture continues understanding xv6, our re-implementation of Unix v6. Read the source code in the assigned files; The assigned chapter for today provides a commentary on the assigned files.</p><p>You won't have to understand the details yet; we will focus on how the first user-level process comes into existence after the computer is turned on.</p><h2>Hand-In Procedure</h2>You are to turn in this homework during lecture. Please write up your answers to the exercises below and hand them in to a 6.828 staff member at the beginning of lecture.<h2>Assignment</h2>Fetch the xv6 source:<pre>
$ mkdir 6.828
$ cd 6.828
$ git clone git://pdos.csail.mit.edu/xv6/xv6.git
Cloning into xv6...
...
$
</pre>Build xv6:<pre>
$ add -f 6.828
$ cd xv6
$ make
...
gcc -O -nostdinc -I. -c bootmain.c
gcc -nostdinc -I. -c bootasm.S
ld -m    elf_i386 -N -e start -Ttext 0x7C00 -o bootblock.o bootasm.o bootmain.o
objdump -S bootblock.o > bootblock.asm
objcopy -S -O binary -j .text bootblock.o bootblock
...
$ 
</pre>Find the address of <code>_start</code>, the entry point of the kernel:<pre>
$ nm kernel | grep _start
8010b50c D _binary_entryother_start
8010b4e0 D _binary_initcode_start
0010000c T _start
</pre>In this case, the address is <code>0010000c</code>.<p>Run the kernel inside QEMU GDB, setting a breakpoint at <code>_start</code> (i.e., the address you just found).</p><pre>
$ make qemu-gdb
...
$ gdb
GNU gdb 6.8-debian
Copyright (C) 2008 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.  Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-linux-gnu".
+ target remote localhost:26000
The target architecture is assumed to be i8086
[f000:fff0]    0xffff0:	ljmp   $0xf000,$0xe05b
0x0000fff0 in ?? ()
+ symbol-file kernel
(gdb) br * 0x0010000c
Breakpoint 1 at 0x10000c
(gdb) c
Continuing.
The target architecture is assumed to be i386
=> 0x10000c:	mov    %cr4,%eax

Breakpoint 1, 0x0010000c in ?? ()
(gdb)
</pre>The details of what you see are likely to differ from the above output. Look at the registers and the stack contents:<pre>
(gdb) info reg
...
(gdb) x/24x $esp
...
(gdb)
</pre>Which part of the stack printout is actually the stack? (Hint: not all of it.) Identify all the non-zero values on the stack.<div class="question"><p><b>Submit</b>: The output of <tt>x/24x $esp</tt> with the valid part of the stack marked. Write a short (3-5 word) comment next to each non-zero value explaining what it is.</p></div><!--

XXX Out of date for xv6 paging

Run
<pre>
make CPUS=1 qemu-gdb
</pre>

This will run QEMU with just one CPU.  Set a breakpoint at 0x0,
set it running, and continue past the first break:

<pre>
[f000:fff0] 0xffff0:    ljmp   $0xf000,$0xe05b
0x0000fff0 in ?? ()
(gdb) br * 0x0
Breakpoint 1 at 0x0
(gdb) c
Continuing.
[f000:   0] 0xf0000:    add    %al,(%bx,%si)

Breakpoint 1, 0x00000000 in ?? ()
(gdb) c
Continuing.
The target architecture is assumed to be i386
0x0:    push   $0x24

Breakpoint 1, 0x00000000 in ?? ()
(gdb) 
</pre>

The code that is running is from <tt>initcode.S</tt>; the
<tt>push 0x00000024</tt> is the first instruction of the first
user-level process. <tt>0x24</tt> is the address of some data; the
process is pushing the address so that the kernel can later
fetch the data.

<div class="question">
<b>Turn in</b>: What physical address does the <tt>0x24</tt>
translate to? That is, if the code were at this point to load
32 bits from address <tt>0x24</tt>, from what physical address
would the data be fetched? What is the data at that address?
</div>

Hint: You can use <tt>&lt;Ctrl-a c&gt;</tt> in the terminal you launched
QEMU in to switch between the console and the QEMU monitor.  The QEMU
monitor command <tt>info registers</tt> will print information about
segments. You can use the <tt>xp /1xw addr</tt> QEMU monitor command to
print one 32-bit value from physical memory. 

--></body></html>